/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package groovy.bugs;

import java.util.HashMap;

/**
 * Class to support the GROOVY-662 test.  There is a difference between improper uses of
 * properties between Groovy defined classes and Java defined classes.  There is no difference
 * between correct uses so this is not a problem just an anti-regression test.
 *
 * @author Russel Winder
 */
public class Groovy662_JavaClass extends HashMap {
    String myProperty = "Hello";

    public String getMyProperty() {
        return myProperty;
    }
}
